AbstractConfiguration (Apache Geode 1.12.4)
Date: 2021-07-21

org.apache.geode.management.configuration

## Class AbstractConfiguration<R extends RuntimeInfo>

- java.lang.Object
- - org.apache.geode.management.configuration.AbstractConfiguration<R>

- Type Parameters:
    `R` - the RuntimeInfo that corresponds to this configuration. Each non-abstract subclass needs to supply this when it extends this class.
  All Implemented Interfaces:
    Serializable, Identifiable<String>, JsonSerializable
  Direct Known Subclasses:
    GroupableConfiguration, Index, Pdx

      @Experimental
      public abstract class AbstractConfiguration<R extends RuntimeInfo>
      extends Object
      implements Identifiable<String>, JsonSerializable

  This class represents either a configuration or a filter.

  As a configuration of a managed entity it can be used to either create, update, or delete it, or to describe it in the result of list or get.

  As a filter as input to list or get it can be used to specify what entities to return.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CLUSTER` The reserved group name that represents the predefined "cluster" group.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractConfiguration()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getGroup()`
    `static String` | `getGroupName(String group)`
    `abstract String` | `getId()` Returns the attribute of the configuration that uniquely identifies it
    `abstract Links` | `getLinks()` for internal usage only
    `static boolean` | `isCluster(String groupName)` Returns true if the given "groupName" represents the predefined "cluster" group.
    `boolean` | `isGlobalRuntime()` Returns true if the RuntimeInfo will be the same on all members; false if each member can have different RuntimeInfo.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.geode.lang.Identifiable

      `exists, find, remove`

- - ### Field Detail

    - #### CLUSTER

          public static final String CLUSTER

      The reserved group name that represents the predefined "cluster" group. Every member of a cluster automatically belongs to this group. Note that this cluster group name is not allowed in some contexts. For example when creating a region, instead of setting the group to CLUSTER, you need to set it to NULL or just let it default.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractConfiguration

          public AbstractConfiguration()

  - ### Method Detail

    - #### isCluster

          public static boolean isCluster(String groupName)

      Returns true if the given "groupName" represents the predefined "cluster" group. This is true if "groupName" is a case-insensitive match for `CLUSTER`, is `null`, or is an empty string.

    - #### getGroupName

          public static String getGroupName(String group)

    - #### getGroup

          public String getGroup()

    - #### getId

          public abstract String getId()

      Returns the attribute of the configuration that uniquely identifies it
      Specified by:
        `getId` in interface `Identifiable<String>`
      Returns:
        an identifier uniquely identifying this Object.

    - #### getLinks

          public abstract Links getLinks()

      for internal usage only

    - #### isGlobalRuntime

          public boolean isGlobalRuntime()

      Returns true if the RuntimeInfo will be the same on all members; false if each member can have different RuntimeInfo.